
package masterthesis;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class Preprocessing {
    private Scanner icdFile, stopWordsFile;
    private PrintWriter printer;
 
    ArrayList<ArrayList<String>> icd, sct;
    ArrayList<String> stopWords;
 
 
    public Preprocessing() throws FileNotFoundException{
        
        this.stopWordsFile = new Scanner(new File("stopwords.txt")); //  file with stopwords (see exemple file stopwords.txt)
        this.icd = new ArrayList<> ();
        this.stopWords = new ArrayList<> ();
        this.printer = new PrintWriter(new File("icd.txt")); 
    }
    
    
    public void stopWordRemover(){
        while(stopWordsFile.hasNext()){
            stopWords.add(stopWordsFile.next());
        }   
    }
    
    public void normalizer(ArrayList<ArrayList<String>> list,String filename1, String filename2)throws FileNotFoundException{
        Scanner sc = new Scanner (new File(filename1));
        printer = new PrintWriter(new File(filename2));
        stopWordRemover();
        while(sc.hasNextLine()){
            list.add(new ArrayList<String>());
            String line = sc.nextLine().toLowerCase().replaceAll("[+.;:^,?!*()]","");
            line=line.replaceAll("\\[", "").replaceAll("\\]","").replaceAll("\"","");
            line=line.replace('-', ' ');
            line=line.replace('/',' ');
            line=line.replace('|',' ');
            line=line.replaceAll("\u00A0", "");
            
            String [] tab = line.split("\t");
            for (String tab1 : tab) {
                ArrayList <String> save = new ArrayList <> ();
                String line2 = tab1;
                Scanner sc1 = new Scanner(line2);
                while(sc1.hasNext()){
                    String wordie = sc1.next();
                    save.add(wordie);
                }
                save.add("\t");
                save.removeAll(stopWords);
                list.get(list.size()-1).addAll(save);
                
            }
        }   
        printPreprocessingToFile(list);
    }
    
    
    public void printPreprocessingToFile(
            ArrayList <ArrayList<String>> line){
        for(int i = 0; i<line.size();i++){
            for (int j=0; j<line.get(i).size(); j++){
                printer.print(line.get(i).get(j));
               if(!line.get(i).get(j).equals("\t")){
                    if(!line.get(i).get(j+1).equals("\t")){
                      printer.print(" "); 
                 }
                }
            }        
            printer.println();
        } 
        printer.close();
    }
}